'*************************** Sample for SWUSB ***************************
'(
Author : Michael Koecher
Www : Http : / / Www.six1.net
Created : 2010 -07 -22
Version : 1.00

Based On Code From
Author : Rick Richard
Www : Http : / / Www.sloservers.com / Swusb
Created : Jul 29 , 2009
Version : 1.00

Copyright By Rick Richard
Http : / / Creativecommons.org / Licenses / By -sa / 3.0 / De/
Http : / / Creativecommons.org / Licenses / By -sa / 3.0 / De / Deed.en
')


$regfile = "m8def.dat"                                      'Chip =17
'$regfile = "m16def.dat"                                     'Chip =18
'$regfile = "m32def.dat"                                     'Chip =23
'$regfile = "m644def.dat"                                    'Chip =37
'$regfile = "m644pdef.dat"                                   'Chip =59
'$regfile = "m1284pdef.dat"                                  'Chip =103
'(
* AT-MEGA 8     = m8def.dat
* AT-MEGA 16    = m16def.dat
* AT-MEGA 32    = m32def.dat
* AT-MEGA 644   = m644def.dat
* AT-MEGA 644P  = m644pdef.dat
* AT-MEGA 1284P = m1284pdef.dat
')


Const Usbdebug = 0
'(
   Enable Debugging Output
      0 = Disable
      1 = Debugging Messages
      2 = Dbg Frame / Stack Output
')

Const _usb_use_eeprom = 0
'(
    Use Eeprom Or Flash To Store Usb Descriptors
    1 = Eeprom , 0 = Flash. Storing To Eeprom Will Reduce Code Size Slightly.
')

   #if Usbdebug = 2
       $dbg
   #endif

   $hwstack = 40
   $swstack = 40
   $framesize = 50

   $crystal = 12000000
   $baud = 57600

   $eepromhex                                               'for STK500 programmer

'Include the software USB library
   $lib "swusb.lbx"
   $external _swusb

   $include "swusb_declarations.inc"

'**************************** USB Init ***************************
Call Usb_reset()
'(
   Set All The Variables , Flags , And Sync Bits To Their Initial States
')

'************************* USB Interrupt *************************
Const _usb_intf = Intf0
Config Int0 = Rising
On Int0 Usb_isr Nosave
Enable Int0


'************************* USB WATCHDOG **************************
Config Watchdog = 2048                                      'reset after 2048 mSec
   Start Watchdog
   Reset Watchdog

'(
  Sample:
          We Use Mega 8 And Want To Have:
           - Portb As Output
           - Portc As Input
           - Portd.4 As 1 -wire Ds1820

  Todo:
         Set Ports As In / Out With Pullup On Inport's
         3k9(4k7) Resistor From Pd.4 To Vcc( + )
         Ds1820 Left / Right Pin On Groud , Middle Pin At Pd.4

         Let's go... :-)
')
     'on PORTB we can only use PB.0 to PB.5  PB.6 and PB.7 is for X-Tal!
     Ddrb = &B0011_1111
     Config Portb = Output
     Portb = &B0000_0000

     'on PORTC we can only use PC.0 to PC.5  PC.6 is /RESET and PB.7 i can't find :-)
     Ddrc = &B0000_0000
     Config Portc = Input
     Portc = &B0011_1111
     'we must know, if PORTC Pin's changed!
     Dim Portc_old As Byte
     Portc_old = Pinc

     'for 1-Wire Sensor we need a timing, because we had to wait a minimum of 750ms between sampling temerature!
     ' following does a 1 second base
     Const Reload = 46875
     Config Timer1 = Timer , Prescale = 256
     Ocr1ah = High(reload)
     Ocr1al = Low(reload)
     Tccr1a = 0
     Set Tccr1b.3
     On Compare1a Isr_sample_temperature
     Enable Compare1a                                       'enable timer1 interrupt (Clock Interrupt)


     'temp defines...
     Config 1wire = Portd.4
     Dim 1wire_array(9) As Byte
     Dim Ds_temp As Integer At 1wire_array(1) Overlay
     Dim W_1wire As Word
     Dim Dsid1(8) As Byte
     W_1wire = 1wirecount()
     Dsid1(1) = 1wsearchfirst()
     1wreset                                                ' reset the bus
     1wwrite &HCC                                           ' skip rom
     1wwrite &H44                                           ' Convert T
     'so far we've done all the work for temperatur! nothing more to do

     Enable Interrupts


' *** MAIN ***
Do
   Reset Watchdog

   Call Usb_check_reset
   If Usb_check_rx() = 1 Then
      'we got Payload!
      'stored in Usb_rx_buffer(1-8)
      'max Payload is defined in swsub_declarations.inc / Caps_inputreportbytelength
      Portb = Usb_rx_buffer(1) And &B0011_1111
      #if Usbdebug > 0
         Print "RX &B" ; Bin(usb_rx_buffer(1))
      #endif
   End If

   If Portc_old <> Pinc Then
       Portc_old = Pinc
       If Usb_txd(2 , Portc_old , 0 , 0 , 0 , 0 , 0 , 0) = 1 Then
         #if Usbdebug > 0
            Print "Send PORTC ok."
         #endif
       Else
         #if Usbdebug > 0
            Print "Send PORTC failed!"
         #endif
       End If
   End If
Loop
' *** END OF MAIN ***



Isr_sample_temperature:
'(
  1 Second Timer For Sending Temp Over Usb
')
       'select device
       1wverify Dsid1(1)
       1wwrite &HBE
       'get temp
       1wire_array(1) = 1wread(9)
       1wreset                                              ' reset the bus
       'start new temp convert
       1wwrite &HCC                                         ' skip rom
       1wwrite &H44                                         ' Convert T

       If Dsid1(1) = &H10 Then                              ' Family Code 10 (DS1820, DS18 S 20)
           Shift Ds_temp , Left , 3                         '9 Bit --> 12 Bit
       End If

       'send temp
       If Usb_txd(1 , 1wire_array(1) , 1wire_array(2) , 0 , 0 , 0 , 0 , 0) = 1 Then
         #if Usbdebug > 0
            Print "Send Temp ok."
         #endif
       Else
         #if Usbdebug > 0
            Print "Send Temp failed!"
         #endif
       End If
Return


$include "swusb_data.inc"
$include "swusb_routines.inc"