'*************************** Sample for SWUSB ***************************
'(
Author : Michael Koecher
Www : Http : / / Www.six1.net
Created : 2010 -07 -22
Version : 1.00

Based On Code From
Author : Rick Richard
Www : Http : / / Www.sloservers.com / Swusb
Created : Jul 29 , 2009
Version : 1.00

Copyright By Rick Richard
Http : / / Creativecommons.org / Licenses / By -sa / 3.0 / De/
Http : / / Creativecommons.org / Licenses / By -sa / 3.0 / De / Deed.en
')


$regfile = "m8def.dat"                                      'Chip =17
'$regfile = "m16def.dat"                                     'Chip =18
'$regfile = "m32def.dat"                                     'Chip =23
'$regfile = "m644def.dat"                                    'Chip =37
'$regfile = "m644pdef.dat"                                   'Chip =59
'$regfile = "m1284pdef.dat"                                  'Chip =103
'(
* AT-MEGA 8     = m8def.dat
* AT-MEGA 16    = m16def.dat
* AT-MEGA 32    = m32def.dat
* AT-MEGA 644   = m644def.dat
* AT-MEGA 644P  = m644pdef.dat
* AT-MEGA 1284P = m1284pdef.dat
')


Const Usbdebug = 0
'(
   Enable Debugging Output
      0 = Disable
      1 = Debugging Messages
      2 = Dbg Frame / Stack Output
')

Const _usb_use_eeprom = 0
'(
    Use Eeprom Or Flash To Store Usb Descriptors
    1 = Eeprom , 0 = Flash. Storing To Eeprom Will Reduce Code Size Slightly.
')

   #if Usbdebug = 2
       $dbg
   #endif

   $hwstack = 40
   $swstack = 40
   $framesize = 50

   $crystal = 12000000
   $baud = 57600

   $eepromhex                                               'for STK500 programmer

'Include the software USB library
   $lib "swusb.lbx"
   $external _swusb

   $include "swusb_declarations.inc"

'**************************** USB Init ***************************
Call Usb_reset()
'(
   Set All The Variables , Flags , And Sync Bits To Their Initial States
')

'************************* USB Interrupt *************************
   Const _usb_intf = Intf0
   Config Int0 = Rising
   On Int0 Usb_isr Nosave
   Enable Int0


'************************* USB WATCHDOG **************************
   Config Watchdog = 2048                                   'reset after 2048 mSec
   Start Watchdog
   Reset Watchdog

   Enable Interrupts


'*** MAIN ***
Do
   Reset Watchdog

   Call Usb_check_reset
   If Usb_check_rx() = 1 Then
      'we got Payload!
      'stored in Usb_rx_buffer(1-8)
      'max Payload is defined in swsub_declarations.inc / Caps_inputreportbytelength
'---> here goes your rx code
   End If

'(
   send something...
   If Usb_txd(2 , Portc , 0 , 0 , 0 , 0 , 0 , 0) = 1 Then
       #if Usbdebug > 0
          Print "Send PORTC ok."
       #endif
   Else
       #if Usbdebug > 0
          Print "Send PORTC failed!"
       #endif
   End If
')
Loop
'*** END OF MAIN ***




$include "swusb_data.inc"
$include "swusb_routines.inc"