unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvComponentBase, JvHidControllerClass, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    HidCtl: TJvHidDeviceController;
    Label1: TLabel;
    Label2: TLabel;
    Shape1: TShape;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    procedure HidCtlDeviceChange(Sender: TObject);
    function HidCtlEnumerate(HidDev: TJvHidDevice;
      const Idx: Integer): Boolean;
    procedure FormShow(Sender: TObject);
    procedure HidCtlDeviceData(HidDev: TJvHidDevice; ReportID: Byte;
      const Data: Pointer; Size: Word);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    CurrentDevice: TJvHidDevice;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.HidCtlDeviceChange(Sender: TObject);
begin
        HidCtl.Enumerate;
end;

function TForm1.HidCtlEnumerate(HidDev: TJvHidDevice;
  const Idx: Integer): Boolean;
begin
      label1.caption := 'No HID device';
      label2.caption := 'OFF';
      if (HidDev.Attributes.VendorID = $AAAA) and (HidDev.Attributes.ProductID = $EF22) then begin
           HidCtl.CheckOutByIndex(CurrentDevice, Idx);
           label1.caption := 'Discovered device';
      end;
      Result := True;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    CurrentDevice:= NIL;
    label1.caption := 'No Device';
    label2.caption := 'OFF';
end;

procedure TForm1.HidCtlDeviceData(HidDev: TJvHidDevice; ReportID: Byte;
  const Data: Pointer; Size: Word);
var
        temp : integer;
        outtemp : single;
        i : integer;
begin
    if cardinal(PChar(Data)[0]) = 1 then begin
        temp := Cardinal(PChar(Data)[2]);
        temp := temp shl 8;
        temp := temp + (Cardinal(PChar(Data)[1]) and $FF);
        outtemp := temp / 16;
        label2.caption := floattostrf(outtemp,fffixed,6,2)+' C';
    end;
    if cardinal(PChar(Data)[0]) = 2 then begin
        For i := 1 To 6 do begin
           If ((Cardinal(PChar(Data)[1]) shr (i-1)) and $01) =  0 then begin
             (findcomponent('Label'+inttostr(i+8)) as TLabel).caption := 'down';
           end Else begin
             (findcomponent('Label'+inttostr(i+8)) as TLabel).caption := 'up';
           End;
        end;

    end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var
      outbyte : integer;
      i : integer;
      Buf: array [0..8] of Byte;
      Written: Cardinal;
      ToWrite: Cardinal;
begin
      outbyte := 0;
      For i := 1 To 6 do begin
        if (findcomponent('Checkbox'+inttostr(i)) as TCheckbox).Checked then
         outbyte := outbyte + (findcomponent('Checkbox'+inttostr(i)) as TCheckbox).tag;
      end;
      if Assigned(CurrentDevice) then begin
         Buf[0] := 0;
         ToWrite := CurrentDevice.Caps.OutputReportByteLength;
         Buf[1] := outbyte;
         ToWrite := 2;
         CurrentDevice.WriteFile(Buf, ToWrite, Written);
      end;


end;

end.
